import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"

UI = {}

import "Darf.Util"
import "Darf.UI"

Player = Turbine.Gameplay.LocalPlayer.GetInstance()

Group = {}

Group.enable_layout_preview = false 

Group.version = "Version " .. plugin:GetVersion()

Group.Default_Settings = {
    Pos = {
        x = UI.SCREEN_W / 2,
        y = UI.SCREEN_H / 2
    },

    toggle   = false,
    toggle_x = UI.SCREEN_W / 2,
    toggle_y = UI.SCREEN_H / 2,

    option   = false,
    option_x = UI.SCREEN_W / 2,
    option_y = UI.SCREEN_H / 2,

    Color = {
        Name                = Color( 255, 255, 255, 255 ),
        Name_Outline        = Color( 0, 0, 0, 255 ),
        Morale              = Color( 65, 145, 65, 191 ),
        Power               = Color( 65, 65, 145, 191 ),
        Wrath               = Color( 191, 145, 25, 191 ),
        Bubble              = Color( 145, 65, 145, 191 ),
        Dead                = Color( 100, 25, 25, 191 ),
        Background          = Color( 25, 25, 25, 191 ),
        Select              = Color( 255, 0, 0, 255 ),
        Hover               = Color( 191, 191, 191, 191 ),
        Player              = Color( 145, 145, 65, 191 ),
        Unique_Morale       = Color( 65, 145, 145, 191 ),
        Unique_Name         = Color( 65, 145, 191, 255 ),
        Unique_Name_Outline = Color( 0, 0, 0, 255 ),
        Threshold           = Color( 145, 65, 65, 191 ),
        Power_Text          = Color( 255, 255, 255, 255 ),
        Morale_Text         = Color( 255, 255, 255, 255 ),
        Special_Effect      = Color( 255, 255, 255, 255 ),

        Class = {
            [ Turbine.Gameplay.Class.Hunter ]     = Color( 145, 191, 65, 191 ),
            [ Turbine.Gameplay.Class.Warden ]     = Color( 191, 65, 145, 191 ),
            [ Turbine.Gameplay.Class.Burglar ]    = Color( 191, 145, 65, 191 ),
            [ Turbine.Gameplay.Class.Captain ]    = Color( 145, 65, 191, 191 ),
            [ Turbine.Gameplay.Class.Champion ]   = Color( 65, 65, 145, 191 ),
            [ Turbine.Gameplay.Class.Guardian ]   = Color( 191, 65, 65, 191 ),
            [ Turbine.Gameplay.Class.Minstrel ]   = Color( 191, 191, 65, 191 ),
            [ Turbine.Gameplay.Class.Beorning ]   = Color( 145, 145, 145, 191 ),
            [ Turbine.Gameplay.Class.LoreMaster ] = Color( 65, 145, 191, 191 ),
            [ Turbine.Gameplay.Class.RuneKeeper ] = Color( 65, 191, 65, 191 ),

            [ Turbine.Gameplay.Class.Weaver ]     = Color( 65, 145, 191, 191 ),
            [ Turbine.Gameplay.Class.Reaver ]     = Color( 65, 65, 145, 191 ),
            [ Turbine.Gameplay.Class.Defiler ]    = Color( 191, 191, 65, 191 ),
            [ Turbine.Gameplay.Class.Stalker ]    = Color( 191, 145, 65, 191 ),
            [ Turbine.Gameplay.Class.WarLeader ]  = Color( 145, 65, 191, 191 ),
            [ Turbine.Gameplay.Class.BlackArrow ] = Color( 145, 191, 65, 191 )
        }
    },

    morale_threshold = 0.5,

    enable_classic_power_bar          = false,

    enable_beorn_wrath_color          = false,

    enable_class_icon                 = true,
    enable_leader_icon                = true,
    enable_player_name                = true,
    enable_power_text                 = false,
    enable_morale_text                = false,
    
    enable_unique_player_name_color   = false,
    
    enable_unique_class_morale_color  = false,
    enable_unique_player_morale_color = false,

    enable_effect                     = true,
    enable_effect_duration            = false,

    enable_special_effect             = true,
    enable_special_effect_duration    = true,

    disable_vanilla_party_ui          = false,
    disable_vanilla_player_ui         = false,
    disable_vanilla_target_ui         = false,

    hide_out_of_combat                = false,
    show_vitals_out_of_group          = false,

    effect = {
    },

    effect_self = {
    },

    effect_blacklist = {
    },

    effect_stack = {
    },

    special_effect = "",

    track_all           = false,
    track_curable       = false,
    track_debuff        = false,
    track_crowd_control = false,

    Frame = {
        Name = {
            x      = 28,
            y      = 4,
            anchor = 1  --Top Left
        },
        Class = {
            x      = 4,
            y      = 4,
            anchor = 1  --Top Left
        },
        Leader = {
            x      = 4,
            y      = 4,
            anchor = 2  --Top Right
        },
        Power_Text = {
            x      = 4,
            y      = 4,
            anchor = 4  --Bottom Left
        },
        Morale_Text = {
            x      = 4,
            y      = 4,
            anchor = 4  --Bottom Left
        },
        Effect = {
            x      = 4,
            y      = 28,
            anchor = 1  --Top Left
        },
        Special_Effect = {
            x      = 4,
            y      = 4,
            anchor = 3  --Bottom Right
        }
    },

    Layout = {
        { -- 1 - 3 Players
            x   = 3,
            y   = 1,
            min = 1,
            max = 3
        },
        { -- 4 - 6 Players
            x   = 3,
            y   = 2,
            min = 4,
            max = 6
        },
        { -- 7 - 12 Players
            x   = 4,
            y   = 3,
            min = 7,
            max = 12
        },
        { -- 13 - 18 Players
            x   = 6,
            y   = 3,
            min = 13,
            max = 18
        },
        { -- 19 - 24 Players
            x   = 6,
            y   = 4,
            min = 19,
            max = 24
        }
    },

    vitals_x    = 152,
    vitals_y    = 70,
    power_size  = 8,

    name_width                  = 92,

    class_icon_size             = 20,
    leader_icon_size            = 16, 

    power_text_format           = 2,
    morale_text_format          = 2,

    selection_size              = 2,

    vitals_external_spacing     = 4,
    vitals_internal_spacing     = 4,

    vertical_layout_direction   = 2,
    horizontal_layout_direction = 2,

    effect_size                 = 18,
    effect_spacing              = 2,
    effect_row_count            = 4,
    effect_flash_threshold      = 5,
    effect_duration_threshold   = 60,

    special_effect_size         = 18,

    player_font_type            = 7,
    player_font_size            = 1,

    power_font_type            = 6,
    power_font_size            = 4,

    morale_font_type            = 6,
    morale_font_size            = 4,
    
    effect_font_type            = 7,
    effect_font_size            = 5,

    special_effect_font_type    = 6,
    special_effect_font_size    = 4,

    player_font_outline         = true,
    power_font_outline          = false,
    morale_font_outline         = false,
    effect_font_outline         = true,
    special_effect_font_outline = false
}

Group.CC = {
    [ "Stunned" ]             = true,
    [ "Knocked Down" ]        = true,
    [ "Dazed" ]               = true,
    [ "Rooted" ]              = true,
    [ "Feared" ]              = true,
    [ "Slow" ]                = true,
    [ "Frost-fingered Fear" ] = true
}

Group.Font = {
    [ 1 ] = { 
        name = "Arial",
        size = {
            12
        }
    },
    [ 2 ] = {
        name = "BookAntiqua",
        size = {
            12,
            14,
            16,
            18,
            20,
            22,
            24,
            26,
            28,
            32,
            36
        }
    },
    [ 3 ] = {
        name = "BookAntiquaBold",
        size = {
            12,
            14,
            18,
            19,
            22,
            24
        }
    },
    [ 4 ] = {
        name = "FixedSys",
        size = {
            15
        }
    },
    [ 5 ] = {
        name = "LucidaConsole",
        size = {
            12
        }
    },
    [ 6 ] = {
        name = "TrajanPro",
        size = {
            13,
            14,
            15,
            16,
            18,
            19,
            20,
            21,
            23,
            24,
            25,
            26,
            28
        }
    },
    [ 7 ] = {
        name = "TrajanProBold",
        size = {
            16,
            22,
            24,
            25,
            30,
            36
        }
    },
    [ 8 ] = {
        name = "Verdana",
        size = {
            10,
            12,
            14,
            16,
            18,
            20,
            22,
            23
        }
    },
    [ 9 ] = {
        name = "VerdanaBold",
        size = {
            16
        }
    },
    [ 10 ] = {
        name = "TimesRoman",
        size = {
            18,
            20,
            22,
            26,
            28,
            30,
            36
        }
    },
    [ 11 ] = {
        name = "TimesRomanBold",
        size = {
            20,
            22
        }
    },
    [ 12 ] = {
        name = "Courier",
        size = {
            12
        }
    }
}

Group.FontSpecial = {
    [ 10 ] = { --TimesRoman
        0x4200000e,
        0x420000f1,
        0x420000f4,
        0x42000169,
        0x42000168,
        0x4200016a,
        0x4200016b
    },
    [ 11 ] = { --TimesRomanBold
        0x4200000f,
        0x42000010
    },
    [ 12 ] = { --Courier12
        0x42000028
    }
}

function Group:GetFont( type, size )
    if Group.FontSpecial[ type ] then
        return Group.FontSpecial[ type ][ size ]
    else
        return Turbine.UI.Lotro.Font[ Group.Font[ type ].name .. Group.Font[ type ].size[ size ] ]
    end
end

Group.Settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "MiniRaid_Settings" )

function table.add( target, source )
    local tbl = source --Wtf is this SSG :P

    for k, v in pairs( tbl ) do
        if type( v ) == "table" then
            if target[ k ] == nil then
                target[ k ] = {}

                table.add( target[ k ], v )

                newSettings = true
            else
                if target[ k ].A and target[ k ].R and target[ k ].G and target[ k ].B then
                    target[ k ] = Turbine.UI.Color( target[ k ].A, target[ k ].R, target[ k ].G, target[ k ].B )
                else
                    table.add( target[ k ], v )
                end
            end
        else
            if target[ k ] == nil then
                target[ k ] = v

                newSettings = true
            end
        end
    end
end

if not Group.Settings then
    Group.Settings = {}

    table.add( Group.Settings, Group.Default_Settings )

    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
else
    local newSettings = false

    table.add( Group.Settings, Group.Default_Settings )

    if newSettings then
        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
    end
end

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, not Group.Settings.disable_vanilla_party_ui )
--[[ Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, not Group.Settings.disable_vanilla_player_ui )
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, not Group.Settings.disable_vanilla_target_ui ) ]]


Group.record      = false
Group.record_list = {}

Group.reload      = true

Group.Party       = {}
Group.PartyName   = {}
Group.PartyCount  = 0
Group.Grid_Size_X = 0
Group.Grid_Size_Y = 0

Group.Layout = Turbine.PluginData.Load( Turbine.DataScope.Character, "MiniRaid_Layout" )

--0x41007DD0 --Voice Active
--0x41007DD1 --Voice Inactive

--0x41007DD1 Color Gradient

--0x410081FC --0x410081C3  --Leader

--0x410E6BF4 Frame

--Size = 36 x 36
--0x410F25C3 Disease
--0x410F25C4 Wound
--0x410F25C5 Fear
--0x410F25C6 Poison
--0x410F25C2 Corruption

Group.ClassIcon = {
    [ Turbine.Gameplay.Class.Hunter ]     = 0x41007dea, --0x410000E8 --0x41007DDA --0x41008201 --0x410095C2                 --0x41108678
    [ Turbine.Gameplay.Class.Warden ]     = 0x410ea239, --0x410095C5 --0x410EA237                                           --0x410F25C2
    [ Turbine.Gameplay.Class.Burglar ]    = 0x41007deb, --0x410000E4 --0x41007DDB --0x41007E87 --0x410095BB                 --0x41108674
    [ Turbine.Gameplay.Class.Captain ]    = 0x41007de7, --0x410000E5 --0x41007DD7 --0x410081F3 --0x410095C5                 --0x41108675
    [ Turbine.Gameplay.Class.Champion ]   = 0x41007dec, --0x410000E6 --0x41007DDC --0x410081CD --0x410095B5                 --0x41108676
    [ Turbine.Gameplay.Class.Guardian ]   = 0x41007de8, --0x410000E7 --0x41007DD8 --0x410081FF --0x410095B8                 --0x41108677
    [ Turbine.Gameplay.Class.Minstrel ]   = 0x41007de6, --0x410000E9 --0x41007DD6 --0x41004C49 --0x410081F7                 --0x4110867A
    [ Turbine.Gameplay.Class.Beorning ]   = 0x4115370d,
    [ Turbine.Gameplay.Class.LoreMaster ] = 0x41007de9, --0x410000E9 --0x41007DD9 --0x410081FC --0x410095BF                 --0x41108679
    [ Turbine.Gameplay.Class.RuneKeeper ] = 0x410ea238, --0x410E6BF4 --0x410EA236                                           --0x4110867B

    [ Turbine.Gameplay.Class.Weaver ]     = 0x41007DEE, --0x41007DE0 --0x41007DCA
    [ Turbine.Gameplay.Class.Reaver ]     = 0x41007DED, --0x41007DDD --0x41007DC9
    [ Turbine.Gameplay.Class.Defiler ]    = 0x410E6BF4, --0x410E6BF5 --0x410E6BF4
    [ Turbine.Gameplay.Class.Stalker ]    = 0x41007DF1, --0x41007DE1 --0x41007DCD
    [ Turbine.Gameplay.Class.WarLeader ]  = 0x41007DF0, --0x41007DDD --0x41007DCC
    [ Turbine.Gameplay.Class.BlackArrow ] = 0x41007DEF  --0x41007DDF --0x41007DCB
}

Group.hidden = false

Group.Toggle = UI:Create( "BASE", nil, function( main )
    main:SetSize( 32, 32 )
    main:SetPos( Group.Settings.toggle_x, Group.Settings.toggle_y )
    main:SetColor( 0, 0, 0, 0 )
    main:SetVisible( Group.Settings.toggle )
    main:SetWantsKeyEvents( true )

    main.ui_toggle    = false
    main.save_visible = main:IsVisible()

    function main:KeyDown( key )
        if key.Action == Turbine.UI.Lotro.Action.Escape then
            if self.ui_toggle then
                self.ui_toggle = false

                self:SetVisible( self.save_visible )
            end
        elseif key.Action == Turbine.UI.Lotro.Action.UI_Toggle then
            self.disable_changed = true

            if self.ui_toggle then
                self:SetVisible( self.save_visible )
            else
                self:SetVisible( false )
            end

            self.disable_changed = false

            self.ui_toggle = not self.ui_toggle
        end
    end

    function main:VisibleChanged()
        if not self.disable_changed then
            self.save_visible = self:IsVisible()
        end
    end

    UI:Create( "IBUTTON", main, function( ui )
        ui:SetBackground( "Darf/MiniRaid/Resources/toggle.tga" )
        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        ui:SetSize( 63, 63 )
        ui:SetStretchMode( 1 )
        ui:SetSize( 32, 32 )
        ui:SetOpacity( 0.5 )

        function ui:MouseEnter()
            self:SetOpacity( 1 )
        end

        function ui:MouseLeave()
            self:SetOpacity( 0.5 )
        end
         
        function ui:MouseDown()
            Group.hidden = not Group.hidden

            if Group.hidden then
                PartyVitals:SetVisible( false )

                ui:SetBackground( "Darf/MiniRaid/Resources/toggle_disabled.tga" )
            else
                ui:SetBackground( "Darf/MiniRaid/Resources/toggle.tga" )

                if Group.Settings.hide_out_of_combat then
                    PartyVitals:SetVisible( Player:IsInCombat() )
                else
                    PartyVitals:SetVisible( true )
                end
            end
        end
    end )
end )

Group.Option = UI:Create( "BASE", nil, function( main )
    main:SetSize( 32, 32 )
    main:SetPos( Group.Settings.option_x, Group.Settings.option_y )
    main:SetColor( 0, 0, 0, 0 )
    main:SetVisible( Group.Settings.option )
    main:SetWantsKeyEvents( true )

    main.ui_toggle    = false
    main.save_visible = main:IsVisible()

    function main:KeyDown( key )
        if key.Action == Turbine.UI.Lotro.Action.Escape then
            if self.ui_toggle then
                self.ui_toggle = false

                self:SetVisible( self.save_visible )
            end
        elseif key.Action == Turbine.UI.Lotro.Action.UI_Toggle then
            self.disable_changed = true

            if self.ui_toggle then
                self:SetVisible( self.save_visible )
            else
                self:SetVisible( false )
            end

            self.disable_changed = false

            self.ui_toggle = not self.ui_toggle
        end
    end

    function main:VisibleChanged()
        if not self.disable_changed then
            self.save_visible = self:IsVisible()
        end
    end

    main.button = UI:Create( "IBUTTON", main, function( ui )
        if Group.Options then
            ui:SetBackground( "Darf/MiniRaid/Resources/button.tga" )
        else
            ui:SetBackground( "Darf/MiniRaid/Resources/button_disabled.tga" )
        end

        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        ui:SetSize( 64, 64 )
        ui:SetStretchMode( 1 )
        ui:SetSize( 32, 32 )
        ui:SetOpacity( 0.5 )

        function ui:MouseEnter()
            self:SetOpacity( 1 )
        end

        function ui:MouseLeave()
            self:SetOpacity( 0.5 )
        end
         
        function ui:MouseDown()
            if Group.Options then
                local visible = Group.Options:IsVisible()

                Group.Options:SetVisible( not visible )

                if visible then
                    ui:SetBackground( "Darf/MiniRaid/Resources/button_disabled.tga" )
                else
                    ui:SetBackground( "Darf/MiniRaid/Resources/button.tga" )
                end
            else
                Group:CreateOptionMenu()

                ui:SetBackground( "Darf/MiniRaid/Resources/button.tga" )
            end
        end
    end )
end )

import "Darf.MiniRaid.settings"
import "Darf.MiniRaid.group"

function Turbine.Plugin:Unload()
    if Group.PartyCount > 1 then
        Group.Layout = {}

        for i = 1, Group.PartyCount do
            Group.Layout[ i ] = Group.Party[ i ]:GetName()
        end

        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Layout", Group.Layout )
    else
        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Layout", false )
    end
end

local status  = 0
control_miniraid = Turbine.UI.Control()

function control_miniraid:Update()
	if status == 1 then
        Turbine.PluginManager.UnloadScriptState( "MiniRaidReload" )
    elseif status > 1 then
        self:SetWantsUpdates( false )
        
        control_miniraid = nil
	end

    status = status + 1
end

control_miniraid:SetWantsUpdates( true )

if Player:GetParty() then
    Group:Create()
else
    if Group.Settings.show_vitals_out_of_group then
        Group:Create( true )
    end
end

if Group.Settings.hide_out_of_combat and not Player:IsInCombat() then
    PartyVitals:SetVisible( false )
end

AddCallback( Player, "InCombatChanged", function() 
    if Group.Settings.hide_out_of_combat and not Player:IsInCombat() then
        PartyVitals:SetVisible( false )
    elseif not Group.hidden then
        PartyVitals:SetVisible( true )
    end
end )

AddCallback( Player, "TargetChanged", function( self )
    Target = self:GetTarget()

    if Target then
        local name = Target:GetName()

        if Group.Selected then
            Group.Selected:SetSelected( false )
        end

        if Group.PartyName and Group.PartyName[ name ] then
            Group.Selected = Group.Party[ Group.PartyName[ name ] ]:SetSelected( true )
        end
    else
        if Group.Selected then
            Group.Selected:SetSelected( false )
        end
    end
end )

AddCallback( Turbine.Chat, "Received", function( self, chat )
    if chat.ChatType == Turbine.ChatType.Fellowship then 
        local raid = string.find( chat.Message, "You have joined the chat room for your raid, raid chat is now available." )

        --Convert to raid
        if raid then
            Turbine.PluginManager.LoadPlugin( "MiniRaidReload" )
        end
    end

	if chat.ChatType == Turbine.ChatType.Standard then
        local fellowship_join, _ = string.find( chat.Message, " has joined your Fellowship." )
        local raid_join, _ = string.find( chat.Message, " has joined your Raid." )

        local fellowship_join_self, _ = string.find( chat.Message, "You have joined a Fellowship." )
        local raid_join_self, _ = string.find( chat.Message, "You have joined a Raid." )

        local fellowship_leave, _ = string.find( chat.Message, " has left your Fellowship." )
        local raid_leave, _ = string.find( chat.Message, " has left your Raid." )

        local fellowship_leave_self, _ = string.find( chat.Message, "You leave your Fellowship." )
        local raid_leave_self, _ = string.find( chat.Message, "You leave your Raid." )

        local _, self_dismissed_start = string.find( chat.Message, "You dismiss " )
        local fellow_dismissed_end, _ = string.find( chat.Message, " from the fellowship." )
        local raid_dismissed_end, _ = string.find( chat.Message, " from the Raid." )

        local fellowship_dismiss, _ = string.find( chat.Message, " has been dismissed from your Fellowship." )
        local raid_dismiss, _ = string.find( chat.Message, " has been dismissed from your Raid." )

        local fellowship_dismiss_self, _ = string.find( chat.Message, "You have been dismissed from your Raid." )
        local raid_dismiss_self, _ = string.find( chat.Message, "You have been dismissed from your Fellowship." )

        local fellowship_disband, _ = string.find( chat.Message, "Your Fellowship has been disbanded." )
        local raid_disband, _ = string.find( chat.Message, "Your Raid has been disbanded." )

        if fellowship_join or raid_join then
            local name = string.sub( chat.Message, 1, ( fellowship_join or raid_join ) - 1 )

            if Group.Settings.show_vitals_out_of_group then
                if Group.PartyCount >= 1 and Group.reload then
                    Group.reload = false

                    Turbine.PluginManager.LoadPlugin( "MiniRaidReload" )
                end
            else
                if Group.PartyCount >= 2 and Group.reload then
                    Group.reload = false

                    Turbine.PluginManager.LoadPlugin( "MiniRaidReload" )
                end
            end
        end

        if fellowship_join_self or raid_join_self then
            if Group.PartyCount < 2 then

                if Group.Settings.show_vitals_out_of_group then
                    Group:Remove()
                end

                Group:Create()
            end
        end

        if fellowship_leave or raid_leave then
            local name = string.sub( chat.Message, 1, ( fellowship_leave or raid_leave ) - 1 )

            if Group.PartyCount > 2 then
                Group:RemoveMember( name )
            elseif Group.PartyCount <= 2 then
                Group:Remove()

                if Group.Settings.show_vitals_out_of_group then
                    Group:Create( true )
                end
            end
        end

        if fellowship_leave_self or raid_leave_self then
            Group:Remove()

            if Group.Settings.show_vitals_out_of_group then
                Group:Create( true )
            end
        end

        if self_dismissed_start and ( fellow_dismissed_end or raid_dismissed_end ) then
            local name = string.sub( chat.Message, self_dismissed_start + 1, ( fellow_dismissed_end or raid_dismissed_end ) - 1 )

            if Group.PartyCount > 2 then
                Group:RemoveMember( name )
            elseif Group.PartyCount <= 2 then
                Group:Remove()

                if Group.Settings.show_vitals_out_of_group then
                    Group:Create( true )
                end
            end
        end

        if fellowship_dismiss or raid_dismiss then
            local name = string.sub( chat.Message, 1, ( fellowship_dismiss or raid_dismiss ) - 1 )

            if Group.PartyCount > 2 then
                Group:RemoveMember( name )
            elseif Group.PartyCount <= 2 then
                Group:Remove()

                if Group.Settings.show_vitals_out_of_group then
                    Group:Create( true )
                end
            end
        end

        if fellowship_dismiss_self or raid_dismiss_self then
            Group:Remove()

            if Group.Settings.show_vitals_out_of_group then
                Group:Create( true )
            end
        end

        if fellowship_disband or raid_disband then
            Group:Remove()

            if Group.Settings.show_vitals_out_of_group then
                Group:Create( true )
            end
        end
    end
end )

command = Turbine.ShellCommand()

function command:Execute( _, str )
    if str == nil or string.len( str ) == 0 then
        return
    end

    local list  = { }
    local index = 1

    for word in str:gmatch( "%w+" ) do
        list[ index ] = word
        index = index + 1
    end

    local cmd = string.lower( list[ 1 ] )

    if cmd == "options" then
        if Group.Options then
            Group.Options:SetVisible( true )
        else
            Group:CreateOptionMenu()
        end
    elseif cmd == "reload" then
        Turbine.PluginManager.LoadPlugin( "MiniRaidReload" )
    elseif cmd == "record" then
        local cmd = string.lower( list[ 2 ] )

        if cmd == "start" then
            Group.record = true

            Print( "MiniRaid: Effect recording started" )
        elseif cmd == "stop" then
            Group.record = false

            Print( "MiniRaid: Effect recording stopped" )

            for k, v in pairs( Group.record_list ) do
                Print( "    " .. "<rgb=#419141>" .. k .. "</rgb>" .. " ( <rgb=#914141>" .. v .. "</rgb> )" )
            end

            Group.record_list = {}
        end
    else
        Turbine.Shell.WriteLine( "Invalid command: " .. cmd )
    end
end

Turbine.Shell.AddCommand( "miniraid", command )

--Debug
--[[ UI:Create( "BASE", nil, function( main )
    main:SetColor( 200, 200, 200, 0 )
    main:SetSize( 56, 16 )
    main:SetPos( 1800, 1416 )

    UI:Create( "BUTTON", main, function( ui )
        ui:SetSize( 56, 16 )
        function ui:Pressed()
            Turbine.PluginManager.LoadPlugin( "MiniRaidReload" )
        end
    end )
end )

Group:CreateOptionMenu() ]]