UI:CreateTemplate( nil, "BASE", function( template )
    template.OBJECT = "BASE"

    function template:Init( META )
        META:SetColor( 200, 200, 200 )
    end

    function template:SetObject( object )
        self.OBJECT = object
    end

    function template:GetObject()
        return self.OBJECT
    end

    function template:CreateObject()
        local object = UI.OBJECT[ self:GetObject() ]

        if object then
            return object()
        end
    end
end )

UI:CreateTemplate( "BASE", "BOX", function( template )
    template:SetObject( "CONTROL" )
end )

UI:CreateTemplate( "BASE", "IBUTTON", function( template )
    template:SetObject( "BUTTON" )

    function template:Init( META )
    end
end )

UI:CreateTemplate( "BASE", "BUTTON", function( template )
    template:SetObject( "CONTROL" )

    function template:Init( META )
        META:SetSize( 56, 16 )

        META.button = UI:Create( "IBUTTON", META, function( ui )
            ui:SetSize( 56, 16 )
            ui:SetColor( 100, 100, 100 )

            ui.background = UI:Create( "BOX", ui, function( ui )
                ui:SetSize( 54, 14 )
                ui:SetPos( 1, 1 )
                ui:SetColor( 25, 25, 25 )
                ui:SetMouseVisible( false )
            end )

            function ui:MouseEnter()
                self.background:SetColor( 50, 50, 50 )
            end

            function ui:MouseLeave()
                self.background:SetColor( 25, 25, 25 )
            end

            function ui:MouseDown()
                self.background:SetColor( 50, 0, 0 )
            end

            function ui:MouseUp()
                if self:IsHovering() then self.background:SetColor( 50, 50, 50 ) end

                META:Pressed()
            end

            ui.text = UI:Create( "TEXT", ui, function( ui )
                ui:SetSize( 56, 16 )
                ui:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                ui:SetText( "Reset" )
                ui:SetMouseVisible( false )
            end )

            function ui:SizeChanged()
                local w, h = self:GetSize()

                self.background:SetSize( w - 2, h - 2 )

                self.text:SetSize( w, h )
            end
        end )

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.button:SetSize( w, h )
            self.button:SizeChanged()
        end

        function META:Pressed()

        end

        function META:SetText( str )
            self.button.text:SetText( str )
        end

        function META:SetFont( font )
            self.button.text:SetFont( font )
        end

        function META:SetTextAlignment( aligment )
            self.button.text:SetTextAlignment( aligment )
        end
    end
end )

UI:CreateTemplate( "BASE", "LBUTTON", function( template )
    template:SetObject( "LBUTTON" )

    function template:Init( META )

    end
end )

UI:CreateTemplate( "BASE", "WINDOW", function( template )
    template:SetObject( "WINDOW" )

    function template:Init( META )

    end
end )

UI:CreateTemplate( "BASE", "EFFECT", function( template )
    template:SetObject( "EFFECT" )

    function template:Init( META )

    end
end )

UI:CreateTemplate( "BASE", "ENTITY", function( template )
    template:SetObject( "ENTITY" )

    function template:Init( META )

    end
end )

UI:CreateTemplate( "BASE", "TEXT", function( template )
    template:SetObject( "TEXT" )
    
    function template:Init( META )
        META:SetText( "N/A" )
    end
end )

UI:CreateTemplate( "BASE", "QUICKSLOT", function( template )
    template:SetObject( "QUICKSLOT" )

    function template:Init( META )

    end
end )

UI:CreateTemplate( "BASE", "TEXTBOX", function( template )
    template:SetObject( "TEXTBOX" )
    
    function template:Init( META )
        META:SetText( "N/A" )
    end
end )

UI:CreateTemplate( "BASE", "LCHECKBOX", function( template )
    template:SetObject( "CHECKBOX" )
    
    function template:Init( META )
    end
end )

UI:CreateTemplate( "BASE", "CHECKBOX", function( template )
    template:SetObject( "CONTROL" )
    
    function template:Init( META )
        META:SetSize( 16, 16 )
        META:SetColor( 100, 100, 100 )

        META.checked = false

        UI:Create( "BOX", META, function( ui )
            ui:SetPos( 1, 1 )
            ui:SetSize( 14, 14 )
            ui:SetColor( 25, 25, 25 )
            ui:SetMouseVisible( false )
        end )

        META.checkbox = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 3, 3 )
            ui:SetSize( 10, 10 )
            ui:SetColor( 25, 25, 25 )
            ui:SetMouseVisible( false )
        end )

        function META:MouseEnter()
            self.checkbox:SetColor( 50, 50, 50 )
        end

        function META:MouseLeave()
            if self.checked then
                self.checkbox:SetColor( 200, 200, 200 )
            else
                self.checkbox:SetColor( 25, 25, 25 )
            end
        end

        function META:MouseDown()
            self.checkbox:SetColor( 50, 0, 0 )
        end

        function META:MouseUp()
            self:SetChecked( not self.checked )

            if not self.checked then
                self.checkbox:SetColor( 25, 25, 25 )
            end
        end

        function META:IsChecked()
            return self.checked
        end

        function META:SetChecked( checked )
            self.checked = checked

            if checked then
                self.checkbox:SetColor( 200, 200, 200 )
            else
                self.checkbox:SetColor( 25, 25, 25 )
            end

            self:CheckedChanged()
        end

        function META:CheckedChanged()

        end
    end
end )

UI:CreateTemplate( "BASE", "SCROLL", function( template )
    template:SetObject( "SCROLL" )
    
    function template:Init( META )
    end
end )

UI:CreateTemplate( "BASE", "LIST", function( template )
    template:SetObject( "LIST" )
    
    function template:Init( META )

        function META:SetHeightToChildren( offset )
            local children = self:GetChildren()

            local h = 0

            for i = 1, #children do
                h = h + children[ i ]:GetHeight()
            end

            local height = h + ( offset or 0 )

            self:SetHeight( height )

            return height
        end

        function META:AddFiller( x, y )
            self:AddItem(
                UI:Create( "BOX", self, function( ui )
                    ui:SetSize( x, y )
                    ui:SetColor( 0, 0, 0, 0 )
                    ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                end )
            )
        end
    end
end )

UI:CreateTemplate( "BASE", "SCROLLBOX", function( template )
    template:SetObject( "CONTROL" )
    
    function template:Init( META )
        META:SetSize( 200, 200 )

        local arrowUp          = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_up.tga" )
        local arrowUpHover     = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_up_hover.tga" )
        local arrowUpPressed   = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_up_pressed.tga" )
        local arrowDown        = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_down.tga" )
        local arrowDownHover   = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_down_hover.tga" )
        local arrowDownPressed = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_down_pressed.tga" )

        META.scroll = UI:Create( "SCROLL", META, function( ui )
            ui:SetPos( 200 - 16, 0 )
            ui:SetSize( 16, 200 )
            ui:SetOrientation( Turbine.UI.Orientation.Vertical )

            ui.background = UI:Create( "IBUTTON", ui, function( ui )
                ui:SetPos( 4, 0 )
                ui:SetSize( 16, 128 )
                ui:SetColor( 50, 50, 50 )
            end )

            function ui:SizeChanged()
                local w, h = self:GetSize()

                self.background:SetSize( w - 8, h )
            end

            ui:SetThumbButton( 
                UI:Create( "BOX", ui, function( ui )
                    ui:SetSize( 16, 128 )
                    ui:SetColor( 150, 150, 150, 0 )
                    ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                    ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )

                    META.thumb = ui

                    ui.top = UI:Create( "BOX", ui, function( ui )
                        ui:SetColor( 0, 0, 0, 0 )
                        ui:SetPos( -2, -2 )
                        ui:SetBackground( arrowUp )
                        ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
                        ui:SetSize( 16, 16 )
                        ui:SetMouseVisible( false )
                    end )

                    ui.middle = UI:Create( "BOX", ui, function( ui )
                        ui:SetPos( 0, 16 - 4 )
                        ui:SetSize( 12, 128 - 16 * 2 + 8 )
                        ui:SetColor( 150, 150, 150 )
                        ui:SetMouseVisible( false )
                    end )

                    ui.bottom = UI:Create( "BOX", ui, function( ui )
                        ui:SetColor( 0, 0, 0, 0 )
                        ui:SetPos( -2, 128 - 16 + 2 )
                        ui:SetBackground( arrowDown )
                        ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
                        ui:SetSize( 16, 16 )
                        ui:SetMouseVisible( false )
                    end )

                    function ui:SizeChanged()
                        local w, h = self:GetSize()

                        self.middle:SetSize( 12, h - 16 * 2 + 8 )

                        self.bottom:SetPos( -2, h - 16 + 2 )
                    end

                    function ui:MouseEnter()
                        if self.dragging then return end

                        self.top:SetBackground( arrowUpHover )
                        self.middle:SetColor( 200, 200, 200 )
                        self.bottom:SetBackground( arrowDownHover )
                    end

                    function ui:MouseLeave()
                        if self.dragging then return end

                        self.top:SetBackground( arrowUp )
                        self.middle:SetColor( 150, 150, 150 )
                        self.bottom:SetBackground( arrowDown )
                    end

                    function ui:MouseDown()
                        self.top:SetBackground( arrowUpPressed )
                        self.middle:SetColor( 100, 100, 100 )
                        self.bottom:SetBackground( arrowDownPressed )

                        self.dragging = true
                    end

                    function ui:MouseUp()
                        if self:IsHovering() then
                            self.top:SetBackground( arrowUpHover )
                            self.middle:SetColor( 200, 200, 200 )
                            self.bottom:SetBackground( arrowDownHover )
                        else
                            self.top:SetBackground( arrowUp )
                        self.middle:SetColor( 150, 150, 150 )
                        self.bottom:SetBackground( arrowDown )
                        end

                        self.dragging = false
                    end
                end )
            )
        end )
    
        META.list = UI:Create( "LIST", META, function( ui )
            ui:SetSize( 200 - 10, 200 )
            ui:SetMouseVisible( false )
            ui:SetVerticalScrollBar( META.scroll )
        end )

        function META:AddItem( ui, slot )
            if slot then 
                self.list:InsertItem( slot, ui )
            else
                self.list:AddItem( ui )
            end

            return ui
        end

        function META:AddFiller( x, y )
            local w, h = self.list:GetSize()

            if self.scroll:GetOrientation() == Turbine.UI.Orientation.Vertical then
                self.list:AddFiller( w, y )
            else
                self.list:AddFiller( x, h )
            end
        end

        function META:Remove( ui )
            if type( ui ) == "number" then 
                self.list:RemoveItemAt( ui )
            else
                self.list:RemoveItem( ui )
            end
        end

        function META:GetItemCount()
            return self.list:GetItemCount()
        end

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.scroll:SetPos( w - 16 + 2, 0 )
            self.scroll:SetSize( 12, h )

        	self.list:SetSize( w - 16 - UI.Spacing, h )
        end
    end
end )

UI:CreateTemplate( "BASE", "SLIDER", function( template )
    template:SetObject( "CONTROL" )

    function template:Init( META )
        local sliderWidget            = Turbine.UI.Graphic( "Darf/UI/Resources/widget.tga" )
        local sliderWidgetHover       = Turbine.UI.Graphic( "Darf/UI/Resources/widget_hover.tga" )
        local sliderWidgetPressed     = Turbine.UI.Graphic( "Darf/UI/Resources/widget_pressed.tga" )
        local sliderLeftArrow         = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_left.tga" )
        local sliderLeftArrowPressed  = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_left_pressed.tga" )
        local sliderLeftArrowHover    = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_left_hover.tga" )
        local sliderRightArrow        = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_right.tga" )
        local sliderRightArrowPressed = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_right_pressed.tga" )
        local sliderRightArrowHover   = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_right_hover.tga" )

        META.sliderMin   = 0
        META.sliderMax   = 100
        META.sliderValue = 0

        META.sliderRange = META.sliderMax - META.sliderMin

        META.keySize   = 16
        META.valueSize = 32

        META:SetSize( 100, 16 )
        META:SetMouseVisible( false )

        META.Key = UI:Create( "TEXT", META, function( ui )
            ui:SetSize( META.keySize, 16 )
            ui:SetText( "N/A" )
            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
            ui:SetMouseVisible( false )
        end )

        META.Value = UI:Create( "TEXTBOX", META, function( ui )
            ui:SetSize( META.valueSize, 16 )
            ui:SetText( "N/A" )
            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
            ui:SetTextAlignment( 5 )

            ui.border = UI:Create( "BORDER", ui, function( ui )
                ui:SetSize( META.valueSize, 16 )
                ui:SetBorderSize( 1 )
                ui:SetBorderColor( Color( 100, 100, 100 ) )
                ui:SetZOrder( 50 )
                ui:SetMouseVisible( false )
            end )

            function ui:SizeChanged()
                local w, h = self:GetSize()

                ui.border:SetSize( w, h )
            end

            function ui:TextChanged()
                local text   = self:GetText()
                local number = tonumber( text )

                if number ~= nil then
                    META:SetValue( number )

                    self.old_text = text
                else
                    if text == "" then
                        META:SetText( text )

                        self.old_text = text
                    else
                        META:SetText( self.old_text )
                    end
                end
            end
        end )

        META.top = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 100, 1 )
            ui:SetColor( 75, 75, 75, 255 )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
            ui:SetMouseVisible( false )
        end )

        META.bottom = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 100, 1 )
            ui:SetColor( 75, 75, 75, 255 )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
            ui:SetMouseVisible( false )
        end )

        META.Background = UI:Create( "BOX", META, function( ui )
            ui:SetColor( 0, 0, 0, 0 )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
            ui:SetSize( 100 - 16 * 2, 16 )
            ui:SetPos( 16, 0 )

            function ui:MouseUp()
                if META.sliderRange < 2 then return end

                if self:IsHovering() then
                    local pos   = self:GetMousePosition() - 8
                    local width = self:GetWidth() - 16

                    if pos < 0 then pos = 0 elseif pos > width then pos = width end

                    META.Widget:SetPos( pos, 0 )

                    META.WidgetPos = pos

                    META.sliderValue = math.round( ( ( META.sliderMax - META.sliderMin ) / width ) * pos ) + META.sliderMin

                    META.Value:SetText( META.sliderValue )

                    META:ValueChanged( META.sliderValue )
                end
            end

            META.Widget = UI:Create( "BOX", ui, function( ui )
                ui:SetColor( 0, 0, 0, 0 )
                ui:SetBackground( sliderWidget )
                ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
                ui:SetSize( 16, 16 )
                ui:SetPos( 16, 0 )
    
                function ui:MouseDown( mouse )
                    if not self.CanDrag then 
                        self.CanDrag   = true 
                        self.DragStart = mouse.X
                    end
    
                    self:SetBackground( sliderWidgetPressed )
                end
    
                function ui:MouseEnter()
                    if self.CanDrag then return end
    
                    self:SetBackground( sliderWidgetHover )
                end
    
                function ui:MouseLeave()
                    if self.CanDrag then return end
    
                    self:SetBackground( sliderWidget )
                end
    
                function ui:MouseUp()
                    if META.sliderRange < 2 then return end

                    if self.CanDrag then 
                        self.CanDrag = false

                        META.Value:SetText( META.sliderValue )
    
                        META:ValueChanged( META.sliderValue )
                    end
    
                    self:SetBackground( sliderWidget )
                end
    
                function ui:MouseMove( mouse )
                    if self.CanDrag then
                        local pos   = self:GetPos() - self.DragStart + mouse.X
                        local width = META.Background:GetWidth() - 16
    
                        if pos < 0 then pos = 0 elseif pos > width then pos = width end
    
                        self:SetPos( pos, 0 )
    
                        META.WidgetPos = pos
    
                        META.sliderValue = math.round( ( ( META.sliderMax - META.sliderMin ) / width ) * pos ) + META.sliderMin
    
                        META.Value:SetText( META.sliderValue )
    
                        META:SliderChanged( META.sliderValue )
                    end
                end
            end )
        end )

        META.ButtonLeft = UI:Create( "IBUTTON", META, function( ui )
            ui:SetBackground( sliderLeftArrow )
            ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
            ui:SetSize( 16, 16 )

            function ui:MouseUp()
                self:SetBackground( sliderLeftArrowHover )

                self:SetWantsUpdates( false )
            end

            function ui:MouseEnter()
                self:SetBackground( sliderLeftArrowHover )
            end

            function ui:MouseLeave()
                self:SetBackground( sliderLeftArrow )
            end

            function ui:MouseDown()
                self:SetBackground( sliderLeftArrowPressed )

                self:Move()

                self.count = 0
                self:SetWantsUpdates( true )
            end

            function ui:Update()
                if self.count == 40 then
                    self:Move()
                else
                    self.count = self.count + 1
                end
            end

            function ui:Move()
                if META.sliderValue <= META.sliderMin then return end

                local max      = META.Background:GetWidth() - 16
                META.WidgetPos = META.WidgetPos - ( max / ( META.sliderMax - META.sliderMin ) )

                if META.WidgetPos <= 0 then META.WidgetPos = 0 end

                META.Widget:SetPos( META.WidgetPos, 0 )

                META.sliderValue = META.sliderValue - 1

                META.Value:SetText( META.sliderValue )
                
                META:ValueChanged( META.sliderValue )
            end
        end )

        META.ButtonRight = UI:Create( "IBUTTON", META, function( ui )
            ui:SetBackground( sliderRightArrow )
            ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
            ui:SetSize( 16, 16 )
            ui:SetPos( 16, 0 )

            function ui:MouseUp()
                self:SetBackground( sliderRightArrowHover )

                self.count = 0
                self:SetWantsUpdates( false )
            end

            function ui:MouseEnter()
                self:SetBackground( sliderRightArrowHover )
            end

            function ui:MouseLeave()
                self:SetBackground( sliderRightArrow )
            end

            function ui:MouseDown()
                self:SetBackground( sliderRightArrowPressed )

                self:Move()

                self.count = 0
                self:SetWantsUpdates( true )
            end

            function ui:Update()
                if self.count == 40 then
                    self:Move()
                else
                    self.count = self.count + 1
                end
            end

            function ui:Move()
                if META.sliderValue >= META.sliderMax then return end

                local width  = META.Background:GetWidth()
                local max    = width - 16

                META.WidgetPos = META.WidgetPos + ( max / ( META.sliderMax - META.sliderMin ) )

                if META.WidgetPos >= width then META.WidgetPos = width end

                META.Widget:SetPos( META.WidgetPos, 0 )

                META.sliderValue = META.sliderValue + 1

                META.Value:SetText( META.sliderValue )
                
                META:ValueChanged( META.sliderValue )
            end
        
        end )

        function META:SetValue( value, disable )
            if value < self.sliderMin then value = self.sliderMin elseif value > self.sliderMax then value = self.sliderMax end

            self.sliderValue = value

            local width = self.Background:GetWidth() - 16
            local total = width / ( self.sliderMax - self.sliderMin )

            self.WidgetPos = ( value - self.sliderMin ) * total

            META.Widget:SetPos( self.WidgetPos, 0 )

            self.Value.old_text = value

            if not disable then
                self.Value:SetText( value )

                self:ValueChanged( value )
            end
        end

        function META:SetRange( min, max )
            self.sliderMin = min
            self.sliderMax = max

            self.sliderRange = max - min
        end

        function META:ValueChanged( value )

        end

        function META:SliderChanged( value )

        end

        function META:SetKey( str )
            self.Key:SetText( str )
        end

        function META:SetKeyColor( color )
            self.Key:SetForeColor( color )
        end

        function META:SetKeySize( size )
            self.keySize = size

            self:SizeChanged()
        end

        function META:SetValueSize( size )
            self.valueSize = size

            self:SizeChanged()
        end

        function META:SetValueAlignment( alignment )
            self.Value:SetTextAlignment( alignment )
        end

        function META:DisableValueEdit( bool )
            self.Value:SetReadOnly( bool )
        end

        function META:SetText( str )
            self.Value:SetText( str )
        end

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.Background:SetPos( 16 + self.keySize, 0 )
            self.Background:SetSize( w - 32 - self.keySize - self.valueSize - 2, 16 )

            self.ButtonLeft:SetPos( self.keySize, 0 )
            self.ButtonRight:SetPos( w - 16 - self.valueSize - 2, 0 )

            self.Value:SetPos( w - self.valueSize, 0 )
            self.Value:SetWidth( self.valueSize )
            self.Value:SizeChanged()

            self.Key:SetWidth( self.keySize )

            self:SetValue( self.sliderValue, true )

            self.top:SetPos( 16 + 2 + self.keySize, 8 - 2 )
            self.top:SetSize( w - 16 * 2 - 4 - self.keySize - self.valueSize - 2, 1 )
    
            self.bottom:SetPos( 16 + 2 + self.keySize, 8 + 1 )
            self.bottom:SetSize( w - 16 * 2 - 4 - self.keySize - self.valueSize - 2, 1 )
        end
    end
end )

UI:CreateTemplate( "BASE", "SLIDER_RESET", function( template )
    template:SetObject( "CONTROL" )

    function template:Init( META )
        META:SetSize( 200, 16 )

        META.buttonSize = 56

        META.slider = UI:Create( "SLIDER", META, function( ui )
            ui:SetWidth( 200 - META.buttonSize - UI.Spacing )
            ui:SetKey( "N/A" )

            function META:SetValue( value, disable )
                ui:SetValue( value, disable )
            end

            function META:SetRange( min, max )
                ui:SetRange( min, max )
            end

            function META:SetText( str )
                ui:SetText( str )
            end

            function META:SetKey( str )
                ui:SetKey( str )
            end

            function ui:ValueChanged( value )
                META:ValueChanged( value )
            end

            function ui:SliderChanged( value )
                META:SliderChanged( value )
            end

            function META:SetKeySize( size )
                ui:SetKeySize( size )
            end
    
            function META:SetValueSize( size )
                ui:SetValueSize( size )
            end

            function META:SetValueAlignment( alignment )
                ui:SetValueAlignment( alignment )
            end

            function META:DisableValueEdit( bool )
                ui:DisableValueEdit( bool )
            end
        end )

        META.button = UI:Create( "BUTTON", META, function( ui )
            ui:SetSize( META.buttonSize, 16 )
            ui:SetPos( 200 - META.buttonSize, 0 )
            ui:SetText( "Reset" )

            function ui:Pressed()
                META:Reset()
            end
        end )

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.slider:SetWidth( w - self.buttonSize - UI.Spacing )
            self.button:SetPos( w - self.buttonSize, 0 )
        end

        function META:SetButtonSize( size )
            self.buttonSize = size

            self.button:SetWidth( size )
            
            self:SizeChanged()
        end

        function META:Reset()

        end

        function META:ValueChanged( value )

        end

        function META:SliderChanged( value )

        end

        function META:SetResetText( str )
            self.button:SetText( str )
        end
    end
end )

UI:CreateTemplate( "BASE", "COLOR_SELECT", function( template )
    template:SetObject( "CONTROL" )
    
    function template:Init( META )
        META:SetSize( 200, 56 + 16 + UI.Spacing * 2 )

        META.color         = Color( 200, 200, 200, 200 )
        META.color_default = Color( 200, 200, 200, 200 )

        META.background = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 56, 56 )
            ui:SetPos( 200 - 56, 0 )
            ui:SetColor( 25, 25, 25, 191 )
        end )

        META.layer = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 56, 56 )
            ui:SetPos( 200 - 56, 0 )
            ui:SetColor( 25, 25, 25, 191 )
            ui:SetVisible( false )
        end )

        META.color_box = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 56, 56 )
            ui:SetPos( 200 - 56, 0 )
            ui:SetColor( META.color )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        end )

        META.r = UI:Create( "SLIDER", META, function( ui )
            ui:SetWidth( 200 - 64 - UI.Spacing )
            ui:SetRange( 0, 255 )
            ui:SetKey( "R" )
            ui:SetKeyColor( Color( 255, 0, 0 ) )

            function ui:ValueChanged( value )
                META.color.R = value / 255

                META.color_box:SetColor( META.color )

                META:ColorChanged( META.color )
            end

            function ui:SliderChanged( value )
                META.color.R = value / 255

                META.color_box:SetColor( META.color )

                META:ColorSliderChanged( META.color )
            end
        end )

        META.g = UI:Create( "SLIDER", META, function( ui )
            ui:SetPos( 0, 16 + UI.Spacing )
            ui:SetWidth( 200 - 64 - UI.Spacing )
            ui:SetRange( 0, 255 )
            ui:SetKey( "G" )
            ui:SetKeyColor( Color( 0, 255, 0 ) )

            function ui:ValueChanged( value )
                META.color.G = value / 255

                META.color_box:SetColor( META.color )

                META:ColorChanged( META.color )
            end

            function ui:SliderChanged( value )
                META.color.G = value / 255

                META.color_box:SetColor( META.color )
                
                META:ColorSliderChanged( META.color )
            end
        end )

        META.b = UI:Create( "SLIDER", META, function( ui )
            ui:SetPos( 0, 32 + UI.Spacing * 2 )
            ui:SetWidth( 200 - 64 - UI.Spacing )
            ui:SetRange( 0, 255 )
            ui:SetKey( "B" )
            ui:SetKeyColor( Color( 0, 0, 255 ) )

            function ui:ValueChanged( value )
                META.color.B = value / 255

                META.color_box:SetColor( META.color )
                
                META:ColorChanged( META.color )
            end

            function ui:SliderChanged( value )
                META.color.B = value / 255

                META.color_box:SetColor( META.color )
                
                META:ColorSliderChanged( META.color )
            end
        end )

        META.a = UI:Create( "SLIDER_RESET", META, function( ui )
            ui:SetPos( 0, 48 + UI.Spacing * 2 + 4 )
            ui:SetWidth( 200 )
            ui:SetRange( 0, 255 )
            ui:SetKey( "A" )

            function ui:ValueChanged( value )
                META.color.A = value / 255

                META.color_box:SetColor( META.color )
                
                META:ColorChanged( META.color )
            end

            function ui:SliderChanged( value )
                META.color.A = value / 255

                META.color_box:SetColor( META.color )
                
                META:ColorSliderChanged( META.color )
            end

            function ui:Reset()
                META:SetInternalColor( META.color_default )

                META:ColorChanged( META.color )

                META:Reset()
            end
        end )

        function META:SetInternalColor( r, g, b, a )
            if type( r ) == "number" then
                self.r:SetValue( r, true )
                self.g:SetValue( g, true )
                self.b:SetValue( b, true )
                self.a:SetValue( a, true )

                self.r:SetText( r )
                self.g:SetText( g )
                self.b:SetText( b )
                self.a:SetText( a )

                self.color_box:SetColor( r, g, b, a )

                self.color = Color( r, g, b, a )
            else
                self.r:SetValue( math.round( 255 * r.R ), true )
                self.g:SetValue( math.round( 255 * r.G ), true )
                self.b:SetValue( math.round( 255 * r.B ), true )
                self.a:SetValue( math.round( 255 * r.A ), true )

                self.r:SetText( math.round( 255 * r.R ) )
                self.g:SetText( math.round( 255 * r.G ) )
                self.b:SetText( math.round( 255 * r.B ) )
                self.a:SetText( math.round( 255 * r.A ) )

                self.color_box:SetColor( r )

                self.color = Turbine.UI.Color( r.A, r.R, r.G, r.B )
            end
        end

        META:SetInternalColor( META.color )

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.r:SetWidth( w - 56 - UI.Spacing )
            self.g:SetWidth( w - 56 - UI.Spacing )
            self.b:SetWidth( w - 56 - UI.Spacing )
            self.a:SetWidth( w )

            
            self.layer:SetPos( w - 56, 0 )
            self.color_box:SetPos( w - 56, 0 )
            self.background:SetPos( w - 56, 0 )
        end

        function META:SetDefaultColor( r, g, b, a )
            if type( r ) == "number" then
                self.color_default = Color( r, g, b, a )
            else
                self.color_default = Turbine.UI.Color( r.A, r.R, r.G, r.B )
            end
        end

        function META:SetBackgroundColor( r, g, b, a )
            self.background:SetColor( r, g, b, a )
        end

        function META:EnableLayer( bool )
            self.layer:SetVisible( bool )
        end

        function META:SetLayerColor( r, g, b, a )
            self.layer:SetColor( r, g, b, a )
        end

        function META:Reset()

        end

        function META:ColorChanged( color )

        end

        function META:ColorSliderChanged( color )

        end
    end
end )

UI:CreateTemplate( "BASE", "DROPDOWN", function( template )
    template:SetObject( "CONTROL" )

    function template:Init( META )
        local arrow         = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_down.tga" )
        local arrowHover    = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_down_hover.tga" )
        local arrowPressed  = Turbine.UI.Graphic( "Darf/UI/Resources/arrow_down_pressed.tga" )

        META:SetSize( 200, 24 )
        META:SetColor( 25, 25, 25, 255 )
        META:SetZOrder( 99 )

        META:SetWantsUpdates( true )

        META.active     = false
        META.listCount  = 0
        META.listHeight = 24

        META.items = {}

        META.text = UI:Create( "TEXT", META, function( ui )
            ui:SetSize( 200, 24 )
            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
            ui:SetTextAlignment( 5 )
            ui:SetMultiline( false )
            ui:SetText( "N/A" )
            ui:SetMouseVisible( false )
        end )

        META.top = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 200, 1 )
            ui:SetColor( 100, 100, 100 )
        end )

        META.bottom = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 0, 24 - 1 )
            ui:SetSize( 200, 1 )
            ui:SetColor( 100, 100, 100 )
        end )

        META.left = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 1, 24 )
            ui:SetColor( 100, 100, 100 )
        end )

        META.right = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 200 - 1, 0 )
            ui:SetSize( 1, 24 )
            ui:SetColor( 100, 100, 100 )
        end )

        META.arrow = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 200 - 16 - UI.Spacing, UI.Spacing )
            ui:SetSize( 16, 16 )
            ui:SetColor( 0, 0, 0, 0 )
            ui:SetBackground( arrow )
            ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
            ui:SetMouseVisible( false )
        end )

        META.dropdown = UI:Create( "BASE", nil, function( ui )
            ui:SetSize( 200, 24 )
            ui:SetColor( 25, 25, 25, 255 )
            ui:SetVisible( false )
            ui:SetZOrder( 100 )

            ui.bottom = UI:Create( "BOX", ui, function( ui )
                ui:SetPos( 0, 24 - 1 )
                ui:SetSize( 200, 1 )
                ui:SetColor( 100, 100, 100 )
                ui:SetZOrder( 101 )
            end )
    
            ui.left = UI:Create( "BOX", ui, function( ui )
                ui:SetSize( 1, 24 )
                ui:SetColor( 100, 100, 100 )
                ui:SetZOrder( 101 )
            end )
    
            ui.right = UI:Create( "BOX", ui, function( ui )
                ui:SetPos( 200 - 1, 0 )
                ui:SetSize( 1, 24 )
                ui:SetColor( 100, 100, 100 )
                ui:SetZOrder( 101 )
            end )

            function ui:SizeChanged()
                local w, h = self:GetSize()
    
                self.bottom:SetPos( 0, h - 1 )
                self.bottom:SetSize( w, 1 )
    
                self.left:SetSize( 1, h )
    
                self.right:SetPos( w - 1, 0 )
                self.right:SetSize( 1, h )
            end
        end )

        function META:MouseEnter()
            if self.active then return end

            self.arrow:SetBackground( arrowHover )
        end

        function META:MouseLeave()
            if self.active then return end

            self.arrow:SetBackground( arrow )
        end

        function META:MouseDown()
            self.arrow:SetBackground( arrowPressed )
        end

        function META:MouseUp()
            if self.listCount == 0 then return end

            if self.active then
                self.arrow:SetBackground( arrowHover )
                self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) )
            else
                self.text:SetForeColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) )
            end
            
            self.bottom:SetVisible( not self.bottom:IsVisible() )

            local visible = self.dropdown:IsVisible()

            self.active = not visible

            self.dropdown:SetVisible( not visible )
        end

        function META:Update()
            if self.active then
                local x, y = self:GetParent():PointToScreen( self:GetPos() )

                self.dropdown:SetPos( x, y + self:GetHeight() )

                if not self:IsHovering() and not self.dropdown:IsHovering() then
                    self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) )

                    self.arrow:SetBackground( arrow )

                    self.bottom:SetVisible( true )

                    self.dropdown:SetVisible( false )

                    self.active = false
                end
            end
        end

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.text:SetSize( w, h )

            self.top:SetSize( w, 1 )

            self.bottom:SetPos( 0, h - 1 )
            self.bottom:SetSize( w, 1 )

            self.left:SetSize( 1, h )

            self.right:SetPos( w - 1, 0 )
            self.right:SetSize( 1, h )

            self.arrow:SetPos( w - 16 - UI.Spacing, UI.Spacing )

            self.dropdown:SetWidth( w )

            self.listHeight = h
        end

        function META:SetSelected( ui )
            if self.selected then
                self.selected:SetColor( 0, 0, 0, 0 )
                self.selected:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) )
                self.selected:SetVisible( true )
            end

            self.text:SetText( ui.index )

            self.selected = ui

            self.arrow:SetBackground( arrow )

            self.bottom:SetVisible( true )

            self.dropdown:SetVisible( false )

            self.active = false

            ui:SetVisible( false )

            ui:SetColor( 0, 0, 0, 0 )
            ui:SetForeColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) )

            self:RefreshList()
        end

        function META:RefreshList()
            local index = 0

            for i = 1, #self.items do
                local item = self.items[ i ]

                if item:IsVisible() then
                    item:SetPos( 0, self.listHeight * index )

                    index = index + 1
                end
            end
        end
    
        function META:Add( str, callback )
            local w, h = self:GetSize()

            local item

            UI:Create( "TEXT", self.dropdown, function( ui )
                ui:SetSize( w, h )
                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                ui:SetTextAlignment( 5 )
                ui:SetMultiline( false )
                ui:SetText( str )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui.index = str

                item = ui

                function ui:MouseEnter()
                    if META.selected == self then return end

                    ui:SetColor( 50, 50, 50, 255 )
                end

                function ui:MouseLeave()
                    if META.selected == self then return end

                    ui:SetColor( 0, 0, 0, 0 )
                end

                function ui:MouseUp()
                    if META.selected == self then return end

                    META:SetSelected( self )

                    META.text:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) )

                    if callback then callback( ui, META ) end
                end
            end )

            self.listCount = self.listCount + 1

            self.dropdown:SetHeight( self.listHeight * ( self.listCount - 1 ) )

            self.items[ #self.items + 1 ] = item

            self:RefreshList()

            return item
        end
    end
end )

UI:CreateTemplate( "BASE", "HEADER", function( template )
    template:SetObject( "TEXT" )

    function template:Init( META )
        META:SetSize( 360, 20 )
        META:SetFont( Turbine.UI.Lotro.Font.TrajanPro20 )
        META:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
        META:SetText( "N/A" )
    
        META.underline = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 360, 1 )
            ui:SetPos( 0, 19 )
            ui:SetColor( 100, 100, 100 )
        end )

        function META:SizeChanged()
            local w = self:GetWidth()

            self.underline:SetWidth( w )
        end
    end
end )

UI:CreateTemplate( "BASE", "BORDER", function( template )
    template:SetObject( "CONTROL" )

    function template:Init( META )
        META:SetSize( 100, 100 )
        META:SetMouseVisible( false )

        META.size = 2

        META.top = UI:Create( "BOX", META, function( ui )
            ui:SetSize( 100, META.size )
            ui:SetColor( 100, 100, 100 )
            ui:SetMouseVisible( false )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        end )

        META.bottom = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 0, 100 - META.size )
            ui:SetSize( 100, META.size )
            ui:SetColor( 100, 100, 100 )
            ui:SetMouseVisible( false )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        end )

        META.left = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 0, META.size )
            ui:SetSize( META.size, 100 - META.size * 2 )
            ui:SetColor( 100, 100, 100 )
            ui:SetMouseVisible( false )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        end )

        META.right = UI:Create( "BOX", META, function( ui )
            ui:SetPos( 100 - META.size, META.size )
            ui:SetSize( META.size, 100 - META.size * 2 )
            ui:SetColor( 100, 100, 100 )
            ui:SetMouseVisible( false )
            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        end )

        function META:SizeChanged()
            local w, h = self:GetSize()

            self.top:SetSize( w, self.size )

            self.bottom:SetPos( 0, h - self.size )
            self.bottom:SetSize( w, self.size )

            self.left:SetPos( 0, self.size )
            self.left:SetSize( self.size, h - self.size * 2 )

            self.right:SetPos( w - self.size, self.size )
            self.right:SetSize( self.size, h - self.size * 2 )
        end

        function META:SetBorderSize( size )
            self.size = size

            self:SizeChanged()
        end

        function META:SetBorderColor( color )
            self.top:SetColor( color )

            self.bottom:SetColor( color )

            self.left:SetColor( color )

            self.right:SetColor( color )
        end
    end
end )

UI:CreateTemplate( "BASE", "DIVIDER", function( template )
    template:SetObject( "CONTROL" )

    function template:Init( META )
        META:SetSize( 360, 1 )
        META:SetColor( 100, 100, 100 )
    end
end )