function _G.Print( str )
    Turbine.Shell.WriteLine( "<rgb=#414191>" .. tostring( str ) .. "</rgb>" )
end

function _G.PrintTable( tbl )
    for k, v in pairs( tbl ) do
        Print( "Table[ <rgb=#914141>" .. k .. "</rgb> ] = <rgb=#419141>" .. tostring( v ) .."</rgb>" )
    end
end

function _G.PrintEffect( effect )

    Print( "Effect: " .. "<rgb=#914141>" .. effect:GetName() .. "</rgb>" )
    Print( "[" )

    local duration = effect:GetDuration()
    local description = effect:GetDescription()

    if duration > 86400 then
        duration = "INF"
    end

    if description == "" then
        description = "N/A"
    end

    local tbl = {
        ID = effect:GetID(),
        Category = effect:GetCategory(),
        Icon = effect:GetIcon(),
        Description = description,
        Duration = duration,
        StartTime = effect:GetStartTime(),
        IsCurable = effect:IsCurable(),
        IsDebuff = effect:IsDebuff()--,
        --IsDispellable = effect:IsDispellable() --Not working?
    }

    for k, v in pairs( tbl ) do
        Print( "     [ <rgb=#914141>" .. k .. "</rgb> ] = <rgb=#419141>" .. tostring( v ) .."</rgb>" )
    end

    Print( "]" )
end